## mercurial 3.8.3

=== debian/changelog ===
mercurial (3.8.3-1) unstable; urgency=medium

  * New upstream release
  * Delete
    from_upstream__strip_invalidate_phase_cache_after_stripping_changese
    t_issue5235.patch as it's now included upstream

 -- Javi Merino <vicho@debian.org>  Fri, 03 Jun 2016 08:26:16 +0100

mercurial (3.8.2-2) unstable; urgency=medium

  * Update hgsubversion breaks to 1.8.6-1
  * Add
    from_upstream__strip_invalidate_phase_cache_after_stripping_changese
    t_issue5235.patch to fix test-obsolete.t on powerpc and i386

 -- Javi Merino <vicho@debian.org>  Sat, 28 May 2016 22:45:03 +0200

## mercurial 3.8.4

=== debian/changelog ===
mercurial (3.8.4-1) unstable; urgency=medium

  * New upstream release

 -- Javi Merino <vicho@debian.org>  Sun, 10 Jul 2016 12:38:01 +0100

=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3

opts="uversionmangle=s/-rc/~rc/,pgpsigurlmangle=s/$/.asc/" \
  http://mercurial.selenic.com/release/mercurial-(.*)\.tar\.gz

## mercurial 3.9

=== debian/changelog ===
mercurial (3.9-1) unstable; urgency=medium

  * New upstream release
  * Fix release URL in debian/watch

 -- Javi Merino <vicho@debian.org>  Sun, 07 Aug 2016 11:54:04 +0100

## mercurial 3.9.1

=== Makefile ===
# If you want to change PREFIX, do not just edit it below. The changed
# value wont get passed on to recursive make calls. You should instead
# override the variable on the command like:
#
# % make PREFIX=/opt/ install

export PREFIX=/usr/local
PYTHON=python
$(eval HGROOT := $(shell pwd))
HGPYTHONS ?= $(HGROOT)/build/pythons
PURE=
PYFILES:=$(shell find mercurial hgext doc -name '*.py')
DOCFILES=mercurial/help/*.txt
export LANGUAGE=C
export LC_ALL=C
TESTFLAGS ?= $(shell echo $$HGTESTFLAGS)

# Set this to e.g. "mingw32" to use a non-default compiler.
COMPILER=

COMPILERFLAG_tmp_ =
COMPILERFLAG_tmp_${COMPILER} ?= -c $(COMPILER)
COMPILERFLAG=${COMPILERFLAG_tmp_${COMPILER}}

help:
	@echo 'Commonly used make targets:'
	@echo '  all          - build program and documentation'
	@echo '  install      - install program and man pages to $$PREFIX ($(PREFIX))'
	@echo '  install-home - install with setup.py install --home=$$HOME ($(HOME))'
	@echo '  local        - build for inplace usage'
	@echo '  tests        - run all tests in the automatic test suite'
	@echo '  test-foo     - run only specified tests (e.g. test-merge1.t)'
	@echo '  dist         - run all tests and create a source tarball in dist/'
	@echo '  clean        - remove files created by other targets'
	@echo '                 (except installed files or dist source tarball)'
	@echo '  update-pot   - update i18n/hg.pot'
	@echo
	@echo 'Example for a system-wide installation under /usr/local:'
	@echo '  make all && su -c "make install" && hg version'
	@echo
	@echo 'Example for a local installation (usable in this directory):'
	@echo '  make local && ./hg version'

all: build doc

local:
	$(PYTHON) setup.py $(PURE) \
	  build_py -c -d . \
	  build_ext $(COMPILERFLAG) -i \
	  build_hgexe $(COMPILERFLAG) -i \
	  build_mo
	env HGRCPATH= $(PYTHON) hg version

build:
	$(PYTHON) setup.py $(PURE) build $(COMPILERFLAG)

wheel:
	FORCE_SETUPTOOLS=1 $(PYTHON) setup.py $(PURE) bdist_wheel $(COMPILERFLAG)

doc:
	$(MAKE) -C doc

cleanbutpackages:
	-$(PYTHON) setup.py clean --all # ignore errors from this command
	find contrib doc hgext hgext3rd i18n mercurial tests \
		\( -name '*.py[cdo]' -o -name '*.so' \) -exec rm -f '{}' ';'
	rm -f $(addprefix mercurial/,$(notdir $(wildcard mercurial/pure/[a-z]*.py)))
	rm -f MANIFEST MANIFEST.in hgext/__index__.py tests/*.err
	rm -f mercurial/__modulepolicy__.py
	if test -d .hg; then rm -f mercurial/__version__.py; fi
	rm -rf build mercurial/locale
	$(MAKE) -C doc clean
	$(MAKE) -C contrib/chg distclean

clean: cleanbutpackages
	rm -rf packages

install: install-bin install-doc

install-bin: build
	$(PYTHON) setup.py $(PURE) install --root="$(DESTDIR)/" --prefix="$(PREFIX)" --force

install-doc: doc
	cd doc && $(MAKE) $(MFLAGS) install

install-home: install-home-bin install-home-doc

install-home-bin: build
	$(PYTHON) setup.py $(PURE) install --home="$(HOME)" --prefix="" --force

install-home-doc: doc
	cd doc && $(MAKE) $(MFLAGS) PREFIX="$(HOME)" install

MANIFEST-doc:
	$(MAKE) -C doc MANIFEST

MANIFEST.in: MANIFEST-doc
	hg manifest | sed -e 's/^/include /' > MANIFEST.in
	echo include mercurial/__version__.py >> MANIFEST.in
	sed -e 's/^/include /' < doc/MANIFEST >> MANIFEST.in

dist:	tests dist-notests

dist-notests:	doc MANIFEST.in
	TAR_OPTIONS="--owner=root --group=root --mode=u+w,go-w,a+rX-s" $(PYTHON) setup.py -q sdist

check: tests

tests:
	cd tests && $(PYTHON) run-tests.py $(TESTFLAGS)

test-%:
	cd tests && $(PYTHON) run-tests.py $(TESTFLAGS) $@

testpy-%:
	@echo Looking for Python $* in $(HGPYTHONS)
	[ -e $(HGPYTHONS)/$*/bin/python ] || ( \
	cd $$(mktemp --directory --tmpdir) && \
        $(MAKE) -f $(HGROOT)/contrib/Makefile.python PYTHONVER=$* PREFIX=$(HGPYTHONS)/$* python )
	cd tests && $(HGPYTHONS)/$*/bin/python run-tests.py $(TESTFLAGS)

check-code:
	hg manifest | xargs python contrib/check-code.py

update-pot: i18n/hg.pot

i18n/hg.pot: $(PYFILES) $(DOCFILES) i18n/posplit i18n/hggettext
	$(PYTHON) i18n/hggettext mercurial/commands.py \
	  hgext/*.py hgext/*/__init__.py \
	  mercurial/fileset.py mercurial/revset.py \
	  mercurial/templatefilters.py mercurial/templatekw.py \
	  mercurial/templater.py \
	  mercurial/filemerge.py \
	  mercurial/hgweb/webcommands.py \
	  $(DOCFILES) > i18n/hg.pot.tmp
        # All strings marked for translation in Mercurial contain
        # ASCII characters only. But some files contain string
        # literals like this '\037\213'. xgettext thinks it has to
        # parse them even though they are not marked for translation.
        # Extracting with an explicit encoding of ISO-8859-1 will make
        # xgettext "parse" and ignore them.
	echo $(PYFILES) | xargs \
	  xgettext --package-name "Mercurial" \
	  --msgid-bugs-address "<mercurial-devel@selenic.com>" \
	  --copyright-holder "Matt Mackall <mpm@selenic.com> and others" \
	  --from-code ISO-8859-1 --join --sort-by-file --add-comments=i18n: \
	  -d hg -p i18n -o hg.pot.tmp
	$(PYTHON) i18n/posplit i18n/hg.pot.tmp
        # The target file is not created before the last step. So it never is in
        # an intermediate state.
	mv -f i18n/hg.pot.tmp i18n/hg.pot

%.po: i18n/hg.pot
        # work on a temporary copy for never having a half completed target
	cp $@ $@.tmp
	msgmerge --no-location --update $@.tmp $^
	mv -f $@.tmp $@

# Packaging targets

osx:
	/usr/bin/python2.7 setup.py install --optimize=1 \
	  --root=build/mercurial/ --prefix=/usr/local/ \
	  --install-lib=/Library/Python/2.7/site-packages/
	make -C doc all install DESTDIR="$(PWD)/build/mercurial/"
	mkdir -p $${OUTPUTDIR:-dist}
	pkgbuild --root build/mercurial/ --identifier org.mercurial-scm.mercurial \
	  build/mercurial.pkg
	HGVER=$$((cat build/mercurial/Library/Python/2.7/site-packages/mercurial/__version__.py; echo 'print(version)') | python) && \
	OSXVER=$$(sw_vers -productVersion | cut -d. -f1,2) && \
	productbuild --distribution contrib/macosx/distribution.xml \
	  --package-path build/ \
	  --version "$${HGVER}" \
	  --resources contrib/macosx/ \
	  "$${OUTPUTDIR:-dist/}"/Mercurial-"$${HGVER}"-macosx"$${OSXVER}".pkg

deb:
	contrib/builddeb

ppa:
	contrib/builddeb --source-only

docker-debian-jessie:
	mkdir -p packages/debian-jessie
	contrib/dockerdeb debian jessie

contrib/docker/ubuntu-%: contrib/docker/ubuntu.template
	sed "s/__CODENAME__/$*/" $< > $@

docker-ubuntu-trusty: contrib/docker/ubuntu-trusty
	contrib/dockerdeb ubuntu trusty

docker-ubuntu-trusty-ppa: contrib/docker/ubuntu-trusty
	contrib/dockerdeb ubuntu trusty --source-only

docker-ubuntu-wily: contrib/docker/ubuntu-wily
	contrib/dockerdeb ubuntu wily

docker-ubuntu-wily-ppa: contrib/docker/ubuntu-wily
	contrib/dockerdeb ubuntu wily --source-only

docker-ubuntu-xenial: contrib/docker/ubuntu-xenial
	contrib/dockerdeb ubuntu xenial

docker-ubuntu-xenial-ppa: contrib/docker/ubuntu-xenial
	contrib/dockerdeb ubuntu xenial --source-only

fedora20:
	mkdir -p packages/fedora20
	contrib/buildrpm
	cp rpmbuild/RPMS/*/* packages/fedora20
	cp rpmbuild/SRPMS/* packages/fedora20
	rm -rf rpmbuild

docker-fedora20:
	mkdir -p packages/fedora20
	contrib/dockerrpm fedora20

fedora21:
	mkdir -p packages/fedora21
	contrib/buildrpm
	cp rpmbuild/RPMS/*/* packages/fedora21
	cp rpmbuild/SRPMS/* packages/fedora21
	rm -rf rpmbuild

docker-fedora21:
	mkdir -p packages/fedora21
	contrib/dockerrpm fedora21

centos5:
	mkdir -p packages/centos5
	contrib/buildrpm --withpython
	cp rpmbuild/RPMS/*/* packages/centos5
	cp rpmbuild/SRPMS/* packages/centos5

docker-centos5:
	mkdir -p packages/centos5
	contrib/dockerrpm centos5 --withpython

centos6:
	mkdir -p packages/centos6
	contrib/buildrpm
	cp rpmbuild/RPMS/*/* packages/centos6
	cp rpmbuild/SRPMS/* packages/centos6

docker-centos6:
	mkdir -p packages/centos6
	contrib/dockerrpm centos6

centos7:
	mkdir -p packages/centos7
	contrib/buildrpm
	cp rpmbuild/RPMS/*/* packages/centos7
	cp rpmbuild/SRPMS/* packages/centos7

docker-centos7:
	mkdir -p packages/centos7
	contrib/dockerrpm centos7

.PHONY: help all local build doc cleanbutpackages clean install install-bin \
	install-doc install-home install-home-bin install-home-doc \
	dist dist-notests check tests check-code update-pot \
	osx fedora20 docker-fedora20 fedora21 docker-fedora21 \
	centos5 docker-centos5 centos6 docker-centos6 centos7 docker-centos7

=== debian/changelog ===
mercurial (3.9.1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Disable deb_specific__use_gpg_21_keys_for_test.patch, jessie doesn't use
    gnupg 2.x.

 -- Julien Cristau <jcristau@debian.org>  Fri, 16 Sep 2016 22:28:34 +0200

mercurial (3.9.1-1) unstable; urgency=medium

  * New upstream release signed with a new gpg key
  * Fix "FTBFS: Tests failures" by fixing test-gpg.t's output to take into
    account gpg 2.1's messages when importing classic gpg keyring files.
    (Closes: #835730)

 -- Javi Merino <vicho@debian.org>  Sat, 03 Sep 2016 09:04:00 +0300

mercurial (3.8.3-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Julien Cristau <jcristau@debian.org>  Wed, 15 Jun 2016 14:31:25 +0200

mercurial (3.7.3-1~bpo8+1) jessie-backports; urgency=high

  * Rebuild for jessie-backports.

 -- Julien Cristau <jcristau@debian.org>  Wed, 06 Apr 2016 12:31:09 +0200

mercurial (3.5.2-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Javi Merino <vicho@debian.org>  Sun, 25 Oct 2015 12:26:00 +0000

mercurial (3.4.2-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Javi Merino <vicho@debian.org>  Mon, 03 Aug 2015 21:10:39 +0100

mercurial (3.1.2-2+deb8u1) jessie-security; urgency=high

  * Fix "CVE-2014-9462" by adding patch
    from_upstream__sshpeer_more_thorough_shell_quoting.patch
    (Closes: #783237)

 -- Javi Merino <vicho@debian.org>  Fri, 01 May 2015 19:14:56 +0100

## mercurial 3.9.2

=== debian/changelog ===
mercurial (3.9.2-1) unstable; urgency=medium

  * New upstream release

 -- Javi Merino <vicho@debian.org>  Sat, 22 Oct 2016 19:40:13 +0100

## mercurial 4.0

=== Makefile ===
--- 
+++ 
@@ -164,10 +164,12 @@
 	  --install-lib=/Library/Python/2.7/site-packages/
 	make -C doc all install DESTDIR="$(PWD)/build/mercurial/"
 	mkdir -p $${OUTPUTDIR:-dist}
-	pkgbuild --root build/mercurial/ --identifier org.mercurial-scm.mercurial \
-	  build/mercurial.pkg
 	HGVER=$$((cat build/mercurial/Library/Python/2.7/site-packages/mercurial/__version__.py; echo 'print(version)') | python) && \
 	OSXVER=$$(sw_vers -productVersion | cut -d. -f1,2) && \
+	pkgbuild --root build/mercurial/ \
+	  --identifier org.mercurial-scm.mercurial \
+	  --version "$${HGVER}" \
+	  build/mercurial.pkg && \
 	productbuild --distribution contrib/macosx/distribution.xml \
 	  --package-path build/ \
 	  --version "$${HGVER}" \

=== debian/changelog ===
mercurial (4.0-1+deb9u1) stretch-security; urgency=high

  * CVE-2017-1000116: command injection on clients through malicious ssh URLs
  * CVE-2017-1000115: path traversal via symlink
  * CVE-2017-9462: protect against malicious 'hg serve --stdio' invocations

 -- Julien Cristau <jcristau@debian.org>  Sat, 12 Aug 2017 18:21:47 -0400

mercurial (4.0-1) unstable; urgency=medium

  * New upstream release

 -- Javi Merino <vicho@debian.org>  Wed, 02 Nov 2016 05:50:33 -0600

mercurial (4.0~rc1-1) experimental; urgency=medium

  * First release candidate for mercurial 4.0
  * Remove deb_specific__use_gpg_21_keys_for_test.patch as test-gpg now
    migrates the secret keys at the beginning of the test

 -- Javi Merino <vicho@debian.org>  Sun, 23 Oct 2016 18:15:45 +0100

=== debian/control ===
Source: mercurial
Section: vcs
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders: Vincent Danjean <vdanjean@debian.org>,
 Javi Merino <vicho@debian.org>,
 Tristan Seligmann <mithrandi@debian.org>
Build-Depends: debhelper (>= 9),
 dh-python,
 patchutils (>= 0.2.25),
 gettext,
 python-all-dev (>= 2.6.6-3~),
 python-docutils,
 python-roman,
 zip,
 unzip,
 bash-completion,
 netbase,
Standards-Version: 3.9.8
Homepage: https://www.mercurial-scm.org/
Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/mercurial/trunk/
Vcs-Browser: https://anonscm.debian.org/viewvc/python-apps/packages/mercurial/trunk/
X-Python-Version: >= 2.4

Package: mercurial-common
Architecture: all 
Depends:
 ${misc:Depends},
 ${python:Depends},
 libjs-excanvas
Recommends: mercurial (>= ${source:Version}), ca-certificates
Suggests:
 wish,
 python-mysqldb, 
 python-pygments,
 python-openssl
Breaks: mercurial (<< ${source:Version})
Replaces: mercurial (<< 2.6.3)
Description: easy-to-use, scalable distributed version control system (common files)
 Mercurial is a fast, lightweight Source Control Management system designed
 for efficient handling of very large distributed projects.
 .
 This package contains the architecture independent components of Mercurial,
 and is generally useless without the mercurial package.

Package: mercurial
Architecture: any 
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, ucf (>= 2.0020),
 mercurial-common (= ${source:Version})
Recommends: openssh-client,
Suggests: qct,
 kdiff3 | kdiff3-qt | kompare | meld | tkcvs | mgdiff
Breaks: hgsubversion (<< 1.8.6-1),
 hgview-common (<< 1.8.1),
 mercurial-git (<= 0.8.3-1),
 qct (<< 1.7-2~),
 mercurial-crecord (<= 0.20140626-1),
Description: easy-to-use, scalable distributed version control system
 Mercurial is a fast, lightweight Source Control Management system designed
 for efficient handling of very large distributed projects.
 .
 Its features include:
  * O(1) delta-compressed file storage and retrieval scheme
  * Complete cross-indexing of files and changesets for efficient exploration
    of project history
  * Robust SHA1-based integrity checking and append-only storage model
  * Decentralized development model with arbitrary merging between trees
  * High-speed HTTP-based network merge protocol
  * Easy-to-use command-line interface
  * Integrated stand-alone web interface
  * Small Python codebase
 .
 This package contains the architecture dependent files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python2,bash-completion

PYVERS=$(shell pyversions -vs)
PYVER_DEFAULT=$(shell pyversions -vd)
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

override_dh_auto_build:
	$(MAKE) all
	# Do not start a line with a word with a dot in a manpage
	sed -i -e 's,^[.]\(hgignore\|hg/hgrc\),\\fP\1,' doc/hg.1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         PARALLEL_TEST_JOBS := --jobs $(NJOBS)
endif

ARCH_IS_MIPS := $(if $(subst mips,,$(DEB_HOST_ARCH)),,T)
ARCH_IS_KFREEBSD-i386 := $(if $(subst kfreebsd-i386,,$(DEB_HOST_ARCH)),,T)
ARCH_IS_ARMEL := $(if $(subst armel,,$(DEB_HOST_ARCH)),,T)
ARCH_IS_SPARC := $(if $(subst sparc,,$(DEB_HOST_ARCH)),,T)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# test-pull-pull-corruption tries to execute two hg commands at the
# same time to test for corruption.  It does so by running an hg
# command in the background, sleeping one second and running the
# second command.  In architectures with slow buildds, one second is
# not enough and the second test starts before the first one has
# started printing.  This is hacky and we just enhance the hack by
# incrementing the sleep time in those architectures.
ifneq ($(or $(ARCH_IS_MIPS), $(ARCH_IS_KFREEBSD-i386), $(ARCH_IS_ARMEL), $(ARCH_IS_SPARC)),)
		sed -i.deb-backup -e 's/sleep 1/sleep 2/' $(CURDIR)/tests/test-pull-pull-corruption.t
endif

	http_proxy='' dh_auto_test -- TESTFLAGS="--verbose --timeout 1440 $(PARALLEL_TEST_JOBS) --blacklist $(CURDIR)/debian/mercurial.test_blacklist"

	rename 's/\.deb-backup$$//' $(CURDIR)/tests/*
endif

override_dh_auto_install: $(PYVERS:%=install-python%)

install-python%:
	python$* setup.py install --root $(CURDIR)/debian/tmp --install-layout=deb

override_dh_install:
	dh_install
	if test -d $(CURDIR)/debian/mercurial ; then \
		$(MAKE) -f debian/rules install-archdep ; \
	fi
	if test -d $(CURDIR)/debian/mercurial-common ; then \
		$(MAKE) -f debian/rules install-archindep ;\
	fi

install-archdep:
	# remove arch-independent python stuff
	find debian/mercurial/usr/lib \
		! -name '*.so' ! -type d -delete , \
		-type d -empty -delete

install-archindep:
	# Move templates and help installed by setup.py to their FHS-correct location
	mv $(CURDIR)/debian/mercurial-common/usr/lib/python$(PYVER_DEFAULT)/dist-packages/mercurial/templates \
	   $(CURDIR)/debian/mercurial-common/usr/lib/python$(PYVER_DEFAULT)/dist-packages/mercurial/help \
	   $(CURDIR)/debian/mercurial-common/usr/share/mercurial
	mv $(CURDIR)/debian/mercurial-common/usr/lib/python$(PYVER_DEFAULT)/dist-packages/mercurial/locale \
	   $(CURDIR)/debian/mercurial-common/usr/share
	# If more than one Python version is supported, clean up the templates
	# and help installed for the other versions
	-rm -rf $(CURDIR)/debian/mercurial-common/usr/lib/python*/dist-packages/mercurial/templates \
	        $(CURDIR)/debian/mercurial-common/usr/lib/python*/dist-packages/mercurial/help \
	        $(CURDIR)/debian/mercurial-common/usr/lib/python*/dist-packages/mercurial/locale \
	# excanvas.js is provided by libjs-excanvas
	rm $(CURDIR)/debian/mercurial-common/usr/share/mercurial/templates/static/excanvas.js
	# remove arch-dependent python stuff
	find debian/mercurial-common/usr/lib \
		-name '*.so' ! -type d -delete , \
		-type d -empty -delete

override_dh_python2-arch:
	dh_python2
	find debian/mercurial/usr/share -type d -empty -delete ; \

override_dh_auto_clean: mercurial/__version__.py
	cp -a mercurial/__version__.py mercurial/__version__.py.save
	dh_auto_clean
	mv mercurial/__version__.py.save mercurial/__version__.py
	$(RM) -rv tmp/

mercurial/__version__.py:
	@echo "$@ is missing (you probably call 'make clean' directly)."
	@echo "Restore it from sources before building the package"
	@echo "Aborting."
	exit 1

=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3

opts="uversionmangle=s/-rc/~rc/,pgpsigurlmangle=s/$/.asc/" \
  https://www.mercurial-scm.org/release/mercurial-(.*)\.tar\.gz

## mercurial 4.3.1

=== debian/changelog ===
mercurial (4.3.1-3) unstable; urgency=high

  * Build with -mno-lra on mips64el to work around #871514.

 -- Tristan Seligmann <mithrandi@debian.org>  Sat, 26 Aug 2017 01:38:11 +0200

mercurial (4.3.1-2) unstable; urgency=high

  * Fix or disable some failing tests (closes: #823056, #850234).

 -- Tristan Seligmann <mithrandi@debian.org>  Sat, 12 Aug 2017 14:34:47 +0200

mercurial (4.3.1-1) unstable; urgency=high

  * Urgency high because of important security fixes.
  * New upstream release (closes: #868014).
    - CVE-2017-1000115: Mercurial's symlink auditing was incomplete prior
      to 4.3, and could be abused to write to files outside the
      repository (closes: #871709).
    - CVE-2017-1000116: Mercurial was not sanitizing hostnames passed to
      ssh, allowing shell injection attacks by specifying a hostname
      starting with -oProxyCommand (closes: #871710).
    - CVE-2017-9462: previously fixed in 4.1.3 upstream (closes: #861243).
  * Blacklist test-https.t due to TLS 1.0/1.1 being disabled in OpenSSL in
    unstable.
  * Fix license definitions in debian/copyright.
  * Bump Standards-Version to 4.0.0 (no changes).
  * Run wrap-and-sort -t -s.

 -- Tristan Seligmann <mithrandi@debian.org>  Fri, 11 Aug 2017 05:00:16 +0200

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,10 @@
 PYVERS=$(shell pyversions -vs)
 PYVER_DEFAULT=$(shell pyversions -vd)
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+ifeq ($(DEB_HOST_ARCH),mips64el)
+        # Work around #871514
+        export DEB_CFLAGS_MAINT_APPEND = -mno-lra
+endif
 
 override_dh_auto_build:
 	$(MAKE) all

## mercurial 4.4.1

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,7 @@
 export LANGUAGE=C
 export LC_ALL=C
 TESTFLAGS ?= $(shell echo $$HGTESTFLAGS)
+OSXVERSIONFLAGS ?= $(shell echo $$OSXVERSIONFLAGS)
 
 # Set this to e.g. "mingw32" to use a non-default compiler.
 COMPILER=
@@ -62,9 +63,8 @@
 
 cleanbutpackages:
 	-$(PYTHON) setup.py clean --all # ignore errors from this command
-	find contrib doc hgext hgext3rd i18n mercurial tests \
+	find contrib doc hgext hgext3rd i18n mercurial tests hgdemandimport \
 		\( -name '*.py[cdo]' -o -name '*.so' \) -exec rm -f '{}' ';'
-	rm -f $(addprefix mercurial/,$(notdir $(wildcard mercurial/pure/[a-z]*.py)))
 	rm -f MANIFEST MANIFEST.in hgext/__index__.py tests/*.err
 	rm -f mercurial/__modulepolicy__.py
 	if test -d .hg; then rm -f mercurial/__version__.py; fi
@@ -121,6 +121,10 @@
 
 check-code:
 	hg manifest | xargs python contrib/check-code.py
+
+format-c:
+	clang-format --style file -i \
+	  `hg files 'set:(**.c or **.h) and not "listfile:contrib/clang-format-blacklist"'`
 
 update-pot: i18n/hg.pot
 
@@ -132,6 +136,7 @@
 	  mercurial/templater.py \
 	  mercurial/filemerge.py \
 	  mercurial/hgweb/webcommands.py \
+	  mercurial/util.py \
 	  $(DOCFILES) > i18n/hg.pot.tmp
         # All strings marked for translation in Mercurial contain
         # ASCII characters only. But some files contain string
@@ -141,7 +146,7 @@
         # xgettext "parse" and ignore them.
 	echo $(PYFILES) | xargs \
 	  xgettext --package-name "Mercurial" \
-	  --msgid-bugs-address "<mercurial-devel@selenic.com>" \
+	  --msgid-bugs-address "<mercurial-devel@mercurial-scm.org>" \
 	  --copyright-holder "Matt Mackall <mpm@selenic.com> and others" \
 	  --from-code ISO-8859-1 --join --sort-by-file --add-comments=i18n: \
 	  -d hg -p i18n -o hg.pot.tmp
@@ -159,14 +164,35 @@
 # Packaging targets
 
 osx:
+	rm -rf build/mercurial
 	/usr/bin/python2.7 setup.py install --optimize=1 \
 	  --root=build/mercurial/ --prefix=/usr/local/ \
 	  --install-lib=/Library/Python/2.7/site-packages/
 	make -C doc all install DESTDIR="$(PWD)/build/mercurial/"
+        # Place a bogon .DS_Store file in the target dir so we can be
+        # sure it doesn't get included in the final package.
+	touch build/mercurial/.DS_Store
+        # install zsh completions - this location appears to be
+        # searched by default as of macOS Sierra.
+	install -d build/mercurial/usr/local/share/zsh/site-functions/
+	install -m 0644 contrib/zsh_completion build/mercurial/usr/local/share/zsh/site-functions/_hg
+        # install bash completions - there doesn't appear to be a
+        # place that's searched by default for bash, so we'll follow
+        # the lead of Apple's git install and just put it in a
+        # location of our own.
+	install -d build/mercurial/usr/local/hg/contrib/
+	install -m 0644 contrib/bash_completion build/mercurial/usr/local/hg/contrib/hg-completion.bash
+	make -C contrib/chg \
+	  HGPATH=/usr/local/bin/hg \
+	  PYTHON=/usr/bin/python2.7 \
+	  HGEXTDIR=/Library/Python/2.7/site-packages/hgext \
+	  DESTDIR=../../build/mercurial \
+	  PREFIX=/usr/local \
+	  clean install
 	mkdir -p $${OUTPUTDIR:-dist}
-	HGVER=$$((cat build/mercurial/Library/Python/2.7/site-packages/mercurial/__version__.py; echo 'print(version)') | python) && \
+	HGVER=$$(python contrib/genosxversion.py $(OSXVERSIONFLAGS) build/mercurial/Library/Python/2.7/site-packages/mercurial/__version__.py) && \
 	OSXVER=$$(sw_vers -productVersion | cut -d. -f1,2) && \
-	pkgbuild --root build/mercurial/ \
+	pkgbuild --filter \\.DS_Store --root build/mercurial/ \
 	  --identifier org.mercurial-scm.mercurial \
 	  --version "$${HGVER}" \
 	  build/mercurial.pkg && \
@@ -182,10 +208,17 @@
 ppa:
 	contrib/builddeb --source-only
 
-docker-debian-jessie:
+contrib/docker/debian-%: contrib/docker/debian.template
+	sed "s/__CODENAME__/$*/" $< > $@
+
+docker-debian-jessie: contrib/docker/debian-jessie
 	mkdir -p packages/debian-jessie
 	contrib/dockerdeb debian jessie
 
+docker-debian-stretch: contrib/docker/debian-stretch
+	mkdir -p packages/debian-stretch
+	contrib/dockerdeb debian stretch
+
 contrib/docker/ubuntu-%: contrib/docker/ubuntu.template
 	sed "s/__CODENAME__/$*/" $< > $@
 
@@ -195,17 +228,23 @@
 docker-ubuntu-trusty-ppa: contrib/docker/ubuntu-trusty
 	contrib/dockerdeb ubuntu trusty --source-only
 
-docker-ubuntu-wily: contrib/docker/ubuntu-wily
-	contrib/dockerdeb ubuntu wily
-
-docker-ubuntu-wily-ppa: contrib/docker/ubuntu-wily
-	contrib/dockerdeb ubuntu wily --source-only
-
 docker-ubuntu-xenial: contrib/docker/ubuntu-xenial
 	contrib/dockerdeb ubuntu xenial
 
 docker-ubuntu-xenial-ppa: contrib/docker/ubuntu-xenial
 	contrib/dockerdeb ubuntu xenial --source-only
+
+docker-ubuntu-yakkety: contrib/docker/ubuntu-yakkety
+	contrib/dockerdeb ubuntu yakkety
+
+docker-ubuntu-yakkety-ppa: contrib/docker/ubuntu-yakkety
+	contrib/dockerdeb ubuntu yakkety --source-only
+
+docker-ubuntu-zesty: contrib/docker/ubuntu-zesty
+	contrib/dockerdeb ubuntu zesty
+
+docker-ubuntu-zesty-ppa: contrib/docker/ubuntu-zesty
+	contrib/dockerdeb ubuntu zesty --source-only
 
 fedora20:
 	mkdir -p packages/fedora20
@@ -241,13 +280,13 @@
 
 centos6:
 	mkdir -p packages/centos6
-	contrib/buildrpm
+	contrib/buildrpm --withpython
 	cp rpmbuild/RPMS/*/* packages/centos6
 	cp rpmbuild/SRPMS/* packages/centos6
 
 docker-centos6:
 	mkdir -p packages/centos6
-	contrib/dockerrpm centos6
+	contrib/dockerrpm centos6 --withpython
 
 centos7:
 	mkdir -p packages/centos7
@@ -259,8 +298,22 @@
 	mkdir -p packages/centos7
 	contrib/dockerrpm centos7
 
+linux-wheels: linux-wheels-x86_64 linux-wheels-i686
+
+linux-wheels-x86_64:
+	docker run -e "HGTEST_JOBS=$(shell nproc)" --rm -ti -v `pwd`:/src quay.io/pypa/manylinux1_x86_64 /src/contrib/build-linux-wheels.sh
+
+linux-wheels-i686:
+	docker run -e "HGTEST_JOBS=$(shell nproc)" --rm -ti -v `pwd`:/src quay.io/pypa/manylinux1_i686 linux32 /src/contrib/build-linux-wheels.sh
+
 .PHONY: help all local build doc cleanbutpackages clean install install-bin \
 	install-doc install-home install-home-bin install-home-doc \
-	dist dist-notests check tests check-code update-pot \
-	osx fedora20 docker-fedora20 fedora21 docker-fedora21 \
-	centos5 docker-centos5 centos6 docker-centos6 centos7 docker-centos7
+	dist dist-notests check tests check-code format-c update-pot \
+	osx deb ppa docker-debian-jessie docker-debian-stretch \
+	docker-ubuntu-trusty docker-ubuntu-trusty-ppa \
+	docker-ubuntu-xenial docker-ubuntu-xenial-ppa \
+	docker-ubuntu-yakkety docker-ubuntu-yakkety-ppa \
+	docker-ubuntu-zesty docker-ubuntu-zesty-ppa \
+	fedora20 docker-fedora20 fedora21 docker-fedora21 \
+	centos5 docker-centos5 centos6 docker-centos6 centos7 docker-centos7 \
+	linux-wheels

=== debian/changelog ===
mercurial (4.4.1-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches, remove patches applied upstream.
  * Replace rename with file-rename as this is gone from perl.

 -- Tristan Seligmann <mithrandi@debian.org>  Mon, 13 Nov 2017 06:19:31 +0200

=== debian/control ===
Source: mercurial
Section: vcs
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders:
 Vincent Danjean <vdanjean@debian.org>,
 Javi Merino <vicho@debian.org>,
 Tristan Seligmann <mithrandi@debian.org>,
Build-Depends:
 bash-completion,
 debhelper (>= 9),
 dh-python,
 gettext,
 netbase,
 patchutils (>= 0.2.25),
 python-all-dev (>= 2.6.6-3~),
 python-docutils,
 python-roman,
 rename,
 unzip,
 zip,
Standards-Version: 4.0.0
Homepage: https://www.mercurial-scm.org/
Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/mercurial/trunk/
Vcs-Browser: https://anonscm.debian.org/viewvc/python-apps/packages/mercurial/trunk/
X-Python-Version: >= 2.4

Package: mercurial-common
Architecture: all
Depends: libjs-excanvas, ${misc:Depends}, ${python:Depends}
Recommends: ca-certificates, mercurial (>= ${source:Version})
Suggests: python-mysqldb, python-openssl, python-pygments, wish
Breaks: mercurial (<< ${source:Version})
Replaces: mercurial (<< 2.6.3)
Description: easy-to-use, scalable distributed version control system (common files)
 Mercurial is a fast, lightweight Source Control Management system designed
 for efficient handling of very large distributed projects.
 .
 This package contains the architecture independent components of Mercurial,
 and is generally useless without the mercurial package.

Package: mercurial
Architecture: any
Depends:
 mercurial-common (= ${source:Version}),
 ucf (>= 2.0020),
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Recommends: openssh-client
Suggests: kdiff3 | kdiff3-qt | kompare | meld | tkcvs | mgdiff, qct
Breaks:
 hgsubversion (<< 1.8.7+1517-b3e41b0d50a2-1),
 hgview-common (<< 1.8.1),
 mercurial-crecord (<= 0.20140626-1),
 mercurial-git (<= 0.8.3-1),
 qct (<< 1.7-2~),
Description: easy-to-use, scalable distributed version control system
 Mercurial is a fast, lightweight Source Control Management system designed
 for efficient handling of very large distributed projects.
 .
 Its features include:
  * O(1) delta-compressed file storage and retrieval scheme
  * Complete cross-indexing of files and changesets for efficient exploration
    of project history
  * Robust SHA1-based integrity checking and append-only storage model
  * Decentralized development model with arbitrary merging between trees
  * High-speed HTTP-based network merge protocol
  * Easy-to-use command-line interface
  * Integrated stand-alone web interface
  * Small Python codebase
 .
 This package contains the architecture dependent files.

=== debian/rules ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 	http_proxy='' dh_auto_test -- TESTFLAGS="--verbose --timeout 1440 $(PARALLEL_TEST_JOBS) --blacklist $(CURDIR)/debian/mercurial.test_blacklist"
 
-	rename 's/\.deb-backup$$//' $(CURDIR)/tests/*
+	file-rename 's/\.deb-backup$$//' $(CURDIR)/tests/*
 endif
 
 override_dh_auto_install: $(PYVERS:%=install-python%)

## mercurial 4.5

=== debian/changelog ===
mercurial (4.5-1ubuntu1) bionic; urgency=medium

  * Disble the hg-git autopkg test, the hg-git package is not in Ubuntu.
  * Disble the hgsubversion autopkg test, it's failing itself, and the
    package is outdated.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 11 Feb 2018 19:49:05 +0100

mercurial (4.5-1) unstable; urgency=medium

  * New upstream release.
    - Drop libjs-excanvas as no longer used by upstream.

 -- Tristan Seligmann <mithrandi@debian.org>  Sun, 11 Feb 2018 08:51:26 +0200

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 Package: mercurial-common
 Architecture: all
-Depends: libjs-excanvas, ${misc:Depends}, ${python:Depends}
+Depends: ${misc:Depends}, ${python:Depends}
 Recommends: ca-certificates, mercurial (>= ${source:Version})
 Suggests: python-mysqldb, python-openssl, python-pygments, wish
 Breaks: mercurial (<< ${source:Version})

## mercurial 4.5.2

=== debian/changelog ===
mercurial (4.5.2-1) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

  [ Julien Cristau ]
  * Add Kevin Bullock's key to debian/upstream/signing-key.asc
  * New upstream release

 -- Julien Cristau <jcristau@debian.org>  Wed, 21 Mar 2018 13:32:27 +0100

=== debian/control ===
--- 
+++ 
@@ -21,8 +21,8 @@
  zip,
 Standards-Version: 4.0.0
 Homepage: https://www.mercurial-scm.org/
-Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/mercurial/trunk/
-Vcs-Browser: https://anonscm.debian.org/viewvc/python-apps/packages/mercurial/trunk/
+Vcs-Git: https://salsa.debian.org/python-team/applications/mercurial.git
+Vcs-Browser: https://salsa.debian.org/python-team/applications/mercurial
 X-Python-Version: >= 2.4
 
 Package: mercurial-common

## mercurial 4.5.3

=== Makefile ===
--- 
+++ 
@@ -124,7 +124,7 @@
 
 format-c:
 	clang-format --style file -i \
-	  `hg files 'set:(**.c or **.h) and not "listfile:contrib/clang-format-blacklist"'`
+	  `hg files 'set:(**.c or **.cc or **.h) and not "listfile:contrib/clang-format-blacklist"'`
 
 update-pot: i18n/hg.pot
 
@@ -246,6 +246,12 @@
 docker-ubuntu-zesty-ppa: contrib/docker/ubuntu-zesty
 	contrib/dockerdeb ubuntu zesty --source-only
 
+docker-ubuntu-artful: contrib/docker/ubuntu-artful
+	contrib/dockerdeb ubuntu artful
+
+docker-ubuntu-artful-ppa: contrib/docker/ubuntu-artful
+	contrib/dockerdeb ubuntu artful --source-only
+
 fedora20:
 	mkdir -p packages/fedora20
 	contrib/buildrpm
@@ -314,6 +320,7 @@
 	docker-ubuntu-xenial docker-ubuntu-xenial-ppa \
 	docker-ubuntu-yakkety docker-ubuntu-yakkety-ppa \
 	docker-ubuntu-zesty docker-ubuntu-zesty-ppa \
+	docker-ubuntu-artful docker-ubuntu-artful-ppa \
 	fedora20 docker-fedora20 fedora21 docker-fedora21 \
 	centos5 docker-centos5 centos6 docker-centos6 centos7 docker-centos7 \
 	linux-wheels

=== doc/Makefile ===
SOURCES=$(notdir $(wildcard ../mercurial/help/*.[0-9].txt))
MAN=$(SOURCES:%.txt=%)
HTML=$(SOURCES:%.txt=%.html)
GENDOC=gendoc.py ../mercurial/commands.py ../mercurial/help.py \
	../mercurial/help/*.txt ../hgext/*.py ../hgext/*/__init__.py
PREFIX=/usr/local
MANDIR=$(PREFIX)/share/man
INSTALL=install -c -m 644
PYTHON=python
RSTARGS=

export HGENCODING=UTF-8

all: man html

man: $(MAN)

html: $(HTML)

common.txt $(SOURCES) $(SOURCES:%.txt=%.gendoc.txt): $(GENDOC)
	${PYTHON} gendoc.py "$(basename $@)" > $@.tmp
	mv $@.tmp $@

%: %.txt %.gendoc.txt common.txt
	$(PYTHON) runrst hgmanpage $(RSTARGS) --halt warning \
	  --strip-elements-with-class htmlonly $*.txt $*

%.html: %.txt %.gendoc.txt common.txt
	$(PYTHON) runrst html $(RSTARGS) --halt warning \
	  --link-stylesheet --stylesheet-path style.css $*.txt $*.html

MANIFEST: man html
# tracked files are already in the main MANIFEST
	$(RM) $@
	for i in $(MAN) $(HTML); do \
	  echo "doc/$$i" >> $@ ; \
	done

install: man
	for i in $(MAN) ; do \
	  subdir=`echo $$i | sed -n 's/^.*\.\([0-9]\)$$/man\1/p'` ; \
	  mkdir -p "$(DESTDIR)$(MANDIR)"/$$subdir ; \
	  $(INSTALL) $$i "$(DESTDIR)$(MANDIR)"/$$subdir ; \
	done

clean:
	$(RM) $(MAN) $(HTML) common.txt $(SOURCES) $(SOURCES:%.txt=%.gendoc.txt) MANIFEST

=== contrib/fuzz/Makefile ===
bdiff.o: ../../mercurial/bdiff.c
	clang -g -O1 -fsanitize=fuzzer-no-link,address -c -o bdiff.o \
	  ../../mercurial/bdiff.c

bdiff: bdiff.cc bdiff.o
	clang -DHG_FUZZER_INCLUDE_MAIN=1 -g -O1 -fsanitize=fuzzer-no-link,address \
	  -I../../mercurial bdiff.cc bdiff.o -o bdiff

bdiff-oss-fuzz.o: ../../mercurial/bdiff.c
	$$CC $$CFLAGS -c -o bdiff-oss-fuzz.o ../../mercurial/bdiff.c

bdiff_fuzzer: bdiff.cc bdiff-oss-fuzz.o
	$$CXX $$CXXFLAGS -std=c++11 -I../../mercurial bdiff.cc \
	  bdiff-oss-fuzz.o -lFuzzingEngine -o $$OUT/bdiff_fuzzer

all: bdiff

oss-fuzz: bdiff_fuzzer

.PHONY: all oss-fuzz

=== debian/changelog ===
mercurial (4.5.3-1ubuntu2) bionic; urgency=medium

  * Mark the test-convert-bzr-merges.t as failing (timeout arm64 autopkg test).
  * Correctly pass the test blacklist to the autopkg tests.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Apr 2018 20:37:59 +0200

mercurial (4.5.3-1ubuntu1) bionic; urgency=medium

  * Merge with Debian; remaining changes:
    - Drop hgsubversion test, removed from bionic.
  * Pass the same TESTFLAGS to the autopkg tests, as done for the test
    during package build.
  * Mark the test-http-bad-server.t as failing (Ubuntu ppc64el autopkg test).

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Apr 2018 14:48:43 +0200

mercurial (4.5.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream bugfix release

 -- Julien Cristau <jcristau@debian.org>  Thu, 05 Apr 2018 14:25:18 +0200

mercurial (4.5.2-1ubuntu1) bionic; urgency=medium

  * Drop hgsubversion test, removed from bionic.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 28 Mar 2018 04:29:14 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mercurial
 Section: vcs
 Priority: optional
-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
 Uploaders:
  Vincent Danjean <vdanjean@debian.org>,
  Javi Merino <vicho@debian.org>,

=== debian/rules ===
--- 
+++ 
@@ -80,8 +80,6 @@
 	-rm -rf $(CURDIR)/debian/mercurial-common/usr/lib/python*/dist-packages/mercurial/templates \
 	        $(CURDIR)/debian/mercurial-common/usr/lib/python*/dist-packages/mercurial/help \
 	        $(CURDIR)/debian/mercurial-common/usr/lib/python*/dist-packages/mercurial/locale \
-	# excanvas.js is provided by libjs-excanvas
-	rm $(CURDIR)/debian/mercurial-common/usr/share/mercurial/templates/static/excanvas.js
 	# remove arch-dependent python stuff
 	find debian/mercurial-common/usr/lib \
 		-name '*.so' ! -type d -delete , \

## mercurial 4.6

=== debian/changelog ===
mercurial (4.6-2ubuntu1) cosmic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Mark the test-http-bad-server.t as failing (Ubuntu ppc64el autopkg test).
  * Try to drop the arm64 timeout test, seems to work now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 18 May 2018 14:53:47 +0200

mercurial (4.6-2) unstable; urgency=medium

  * Fix xdiff on 32bit (closes: #898491)

 -- Julien Cristau <jcristau@debian.org>  Sat, 12 May 2018 23:51:44 +0200

mercurial (4.6-1) unstable; urgency=medium

  * Team upload

  [ Julien Cristau ]
  * Make uscan recognize "4.6rc1" as a release candidate
  * New upstream release.
  * Document embedded third party code licenses in debian/copyright.
  * Drop obsolete X-Python-Versions control field.
  * Fix typo in deb_specific__disable_libdir_replacement.patch description
    (thanks, lintian!)
  * Install translations where hg will look for them (closes: #886797)

  [ Matthias Klose ]
  * Pass the same TESTFLAGS to the autopkg tests, as done for the test
    during package build, and make the blacklist work correctly
    (closes: #895200, #893012)
  * Disable hgsubversion and mercurial-git autopkgtests (closes: #890191)

 -- Julien Cristau <jcristau@debian.org>  Fri, 11 May 2018 18:19:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: mercurial
 Section: vcs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
 Uploaders:
  Vincent Danjean <vdanjean@debian.org>,
  Javi Merino <vicho@debian.org>,
@@ -24,7 +23,6 @@
 Homepage: https://www.mercurial-scm.org/
 Vcs-Git: https://salsa.debian.org/python-team/applications/mercurial.git
 Vcs-Browser: https://salsa.debian.org/python-team/applications/mercurial
-X-Python-Version: >= 2.4
 
 Package: mercurial-common
 Architecture: all

=== debian/tests/control ===
Tests: testsuite
Depends: @, zip, unzip, netbase, python-subversion, monotone, cvs, bzr, tla, gcc, python2.7-dev
Restrictions: allow-stderr

## mercurial 4.6.1

=== Makefile ===
--- 
+++ 
@@ -124,7 +124,7 @@
 
 format-c:
 	clang-format --style file -i \
-	  `hg files 'set:(**.c or **.cc or **.h) and not "listfile:contrib/clang-format-blacklist"'`
+	  `hg files 'set:(**.c or **.cc or **.h) and not "listfile:contrib/clang-format-ignorelist"'`
 
 update-pot: i18n/hg.pot
 
@@ -132,8 +132,9 @@
 	$(PYTHON) i18n/hggettext mercurial/commands.py \
 	  hgext/*.py hgext/*/__init__.py \
 	  mercurial/fileset.py mercurial/revset.py \
-	  mercurial/templatefilters.py mercurial/templatekw.py \
-	  mercurial/templater.py \
+	  mercurial/templatefilters.py \
+	  mercurial/templatefuncs.py \
+	  mercurial/templatekw.py \
 	  mercurial/filemerge.py \
 	  mercurial/hgweb/webcommands.py \
 	  mercurial/util.py \
@@ -212,11 +213,9 @@
 	sed "s/__CODENAME__/$*/" $< > $@
 
 docker-debian-jessie: contrib/docker/debian-jessie
-	mkdir -p packages/debian-jessie
 	contrib/dockerdeb debian jessie
 
 docker-debian-stretch: contrib/docker/debian-stretch
-	mkdir -p packages/debian-stretch
 	contrib/dockerdeb debian stretch
 
 contrib/docker/ubuntu-%: contrib/docker/ubuntu.template
@@ -234,23 +233,17 @@
 docker-ubuntu-xenial-ppa: contrib/docker/ubuntu-xenial
 	contrib/dockerdeb ubuntu xenial --source-only
 
-docker-ubuntu-yakkety: contrib/docker/ubuntu-yakkety
-	contrib/dockerdeb ubuntu yakkety
-
-docker-ubuntu-yakkety-ppa: contrib/docker/ubuntu-yakkety
-	contrib/dockerdeb ubuntu yakkety --source-only
-
-docker-ubuntu-zesty: contrib/docker/ubuntu-zesty
-	contrib/dockerdeb ubuntu zesty
-
-docker-ubuntu-zesty-ppa: contrib/docker/ubuntu-zesty
-	contrib/dockerdeb ubuntu zesty --source-only
-
 docker-ubuntu-artful: contrib/docker/ubuntu-artful
 	contrib/dockerdeb ubuntu artful
 
 docker-ubuntu-artful-ppa: contrib/docker/ubuntu-artful
 	contrib/dockerdeb ubuntu artful --source-only
+
+docker-ubuntu-bionic: contrib/docker/ubuntu-bionic
+	contrib/dockerdeb ubuntu bionic
+
+docker-ubuntu-bionic-ppa: contrib/docker/ubuntu-bionic
+	contrib/dockerdeb ubuntu bionic --source-only
 
 fedora20:
 	mkdir -p packages/fedora20
@@ -315,12 +308,16 @@
 .PHONY: help all local build doc cleanbutpackages clean install install-bin \
 	install-doc install-home install-home-bin install-home-doc \
 	dist dist-notests check tests check-code format-c update-pot \
-	osx deb ppa docker-debian-jessie docker-debian-stretch \
+	osx deb ppa \
+	docker-debian-jessie \
+	docker-debian-stretch \
 	docker-ubuntu-trusty docker-ubuntu-trusty-ppa \
 	docker-ubuntu-xenial docker-ubuntu-xenial-ppa \
-	docker-ubuntu-yakkety docker-ubuntu-yakkety-ppa \
-	docker-ubuntu-zesty docker-ubuntu-zesty-ppa \
 	docker-ubuntu-artful docker-ubuntu-artful-ppa \
-	fedora20 docker-fedora20 fedora21 docker-fedora21 \
-	centos5 docker-centos5 centos6 docker-centos6 centos7 docker-centos7 \
+	docker-ubuntu-bionic docker-ubuntu-bionic-ppa \
+	fedora20 docker-fedora20 \
+	fedora21 docker-fedora21 \
+	centos5 docker-centos5 \
+	centos6 docker-centos6 \
+	centos7 docker-centos7 \
 	linux-wheels

=== contrib/fuzz/Makefile ===
--- 
+++ 
@@ -13,8 +13,28 @@
 	$$CXX $$CXXFLAGS -std=c++11 -I../../mercurial bdiff.cc \
 	  bdiff-oss-fuzz.o -lFuzzingEngine -o $$OUT/bdiff_fuzzer
 
-all: bdiff
+x%.o: ../../mercurial/thirdparty/xdiff/x%.c ../../mercurial/thirdparty/xdiff/*.h
+	clang -g -O1 -fsanitize=fuzzer-no-link,address -c \
+	  -o $@ \
+	  $<
 
-oss-fuzz: bdiff_fuzzer
+xdiff: xdiff.cc xdiffi.o xprepare.o  xutils.o
+	clang -DHG_FUZZER_INCLUDE_MAIN=1 -g -O1 -fsanitize=fuzzer-no-link,address \
+	  -I../../mercurial xdiff.cc \
+	  xdiffi.o xprepare.o xutils.o -o xdiff
+
+fuzz-x%.o: ../../mercurial/thirdparty/xdiff/x%.c ../../mercurial/thirdparty/xdiff/*.h
+	$$CC $$CFLAGS -c \
+	  -o $@ \
+	  $<
+
+xdiff_fuzzer: xdiff.cc fuzz-xdiffi.o fuzz-xprepare.o  fuzz-xutils.o
+	$$CXX $$CXXFLAGS -std=c++11 -I../../mercurial xdiff.cc \
+	  fuzz-xdiffi.o fuzz-xprepare.o fuzz-xutils.o \
+	  -lFuzzingEngine -o $$OUT/xdiff_fuzzer
+
+all: bdiff xdiff
+
+oss-fuzz: bdiff_fuzzer xdiff_fuzzer
 
 .PHONY: all oss-fuzz

=== debian/changelog ===
mercurial (4.6.1-1ubuntu1) cosmic; urgency=medium

  * Merge with Debian; remaining changes:
    - Mark the test-convert-bzr-merges.t as failing (timeout arm64 autopkg
      test).
    - Mark the test-http-bad-server.t as failing (Ubuntu ppc64el autopkg test).

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Jun 2018 08:42:05 +0200

mercurial (4.6.1-1) unstable; urgency=medium

  * New upstream bugfix release
    + fix security issues in mpatch (closes: #901050)
    + proposed_upstream__fix_xdiff_32bit.patch: drop, applied upstream

 -- Julien Cristau <jcristau@debian.org>  Fri, 08 Jun 2018 13:56:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mercurial
 Section: vcs
 Priority: optional
-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
 Uploaders:
  Vincent Danjean <vdanjean@debian.org>,
  Javi Merino <vicho@debian.org>,

## mercurial 4.8.1

=== debian/changelog ===
mercurial (4.8.1-3) unstable; urgency=medium

  * Add less to debian/test/control as well to fix test-logtoprocess.t
    (closes: #918558).  Thanks, Graham Inggs!

 -- Julien Cristau <jcristau@debian.org>  Mon, 07 Jan 2019 13:51:50 +0100

mercurial (4.8.1-2) unstable; urgency=medium

  * test: fix test-http-bad-server with current python 2.7 (fixes FTBFS)

 -- Julien Cristau <jcristau@debian.org>  Wed, 12 Dec 2018 06:58:28 +0100

mercurial (4.8.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream bugfix release.

 -- Julien Cristau <jcristau@debian.org>  Tue, 11 Dec 2018 18:14:10 +0100

mercurial (4.8-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS due to test_profile.t failure.
  * Refresh patches.

 -- Julien Cristau <jcristau@debian.org>  Tue, 20 Nov 2018 18:55:40 +0100

mercurial (4.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Add build-dep on "less" for tests.
  * Add test-wireproto-exchangev2.t to blacklist, it seems to be racy.

 -- Julien Cristau <jcristau@debian.org>  Tue, 20 Nov 2018 15:47:36 +0100

mercurial (4.7.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Stop installing mergetools.rc in /etc/mercurial/hgrc.d (closes: #909224).

 -- Julien Cristau <jcristau@mozilla.com>  Thu, 04 Oct 2018 15:10:15 +0200

mercurial (4.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Julien Cristau <jcristau@mozilla.com>  Tue, 04 Sep 2018 18:45:34 +0200

mercurial (4.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * Add Recommends on sensible-utils (thanks, lintian).

 -- Julien Cristau <jcristau@debian.org>  Wed, 08 Aug 2018 14:34:59 +0200
